<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLinhasComprasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLinhasComprasERP
 * @subpackage Arrays
 */
class ArrayOfLinhasComprasERP extends AbstractStructArrayBase
{
    /**
     * The LinhasComprasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LinhasComprasERP[]
     */
    public $LinhasComprasERP;
    /**
     * Constructor method for ArrayOfLinhasComprasERP
     * @uses ArrayOfLinhasComprasERP::setLinhasComprasERP()
     * @param \StructType\LinhasComprasERP[] $linhasComprasERP
     */
    public function __construct(array $linhasComprasERP = array())
    {
        $this
            ->setLinhasComprasERP($linhasComprasERP);
    }
    /**
     * Get LinhasComprasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LinhasComprasERP[]|null
     */
    public function getLinhasComprasERP()
    {
        return isset($this->LinhasComprasERP) ? $this->LinhasComprasERP : null;
    }
    /**
     * Set LinhasComprasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasERP[] $linhasComprasERP
     * @return \ArrayType\ArrayOfLinhasComprasERP
     */
    public function setLinhasComprasERP(array $linhasComprasERP = array())
    {
        foreach ($linhasComprasERP as $arrayOfLinhasComprasERPLinhasComprasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfLinhasComprasERPLinhasComprasERPItem instanceof \StructType\LinhasComprasERP) {
                throw new \InvalidArgumentException(sprintf('The LinhasComprasERP property can only contain items of \StructType\LinhasComprasERP, "%s" given', is_object($arrayOfLinhasComprasERPLinhasComprasERPItem) ? get_class($arrayOfLinhasComprasERPLinhasComprasERPItem) : gettype($arrayOfLinhasComprasERPLinhasComprasERPItem)), __LINE__);
            }
        }
        if (is_null($linhasComprasERP) || (is_array($linhasComprasERP) && empty($linhasComprasERP))) {
            unset($this->LinhasComprasERP);
        } else {
            $this->LinhasComprasERP = $linhasComprasERP;
        }
        return $this;
    }
    /**
     * Add item to LinhasComprasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasERP $item
     * @return \ArrayType\ArrayOfLinhasComprasERP
     */
    public function addToLinhasComprasERP(\StructType\LinhasComprasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LinhasComprasERP) {
            throw new \InvalidArgumentException(sprintf('The LinhasComprasERP property can only contain items of \StructType\LinhasComprasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LinhasComprasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LinhasComprasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LinhasComprasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LinhasComprasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LinhasComprasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LinhasComprasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LinhasComprasERP
     */
    public function getAttributeName()
    {
        return 'LinhasComprasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLinhasComprasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
